#include <newt.h>
#include <stdio.h>
#include <stdlib.h>
#include "address.h"

struct addr_db addrdb[1024];
int count = 0;

void init_addr () {
	int x;
	char tmp, file[256];
	FILE *fd;

	sprintf (file, "%s/.address", getenv ("HOME"));

	if (fd = fopen (file, "r")) {
		for (x = 0; x < 1024; x++) {
			fscanf (fd, "%[^\n]%c", addrdb[x].name, &tmp);
			fscanf (fd, "%[^\n]%c", addrdb[x].lastname, &tmp);
			fscanf (fd, "%[^\n]%c", addrdb[x].tel, &tmp);
			fscanf (fd, "%[^\n]%c", addrdb[x].street, &tmp);
			fscanf (fd, "%[^\n]%c", addrdb[x].city, &tmp);
			fscanf (fd, "%[^\n]%c", addrdb[x].zip, &tmp);
			fscanf (fd, "%[^\n]%c", addrdb[x].state, &tmp);
			fscanf (fd, "%[^\n]%c", addrdb[x].mail, &tmp);
			fscanf (fd, "%[^\n]%c", addrdb[x].home, &tmp);
			fscanf (fd, "%[^\n]%c", addrdb[x].icq, &tmp);
			fscanf (fd, "%[^\n]%c", addrdb[x].irc, &tmp);
			if (feof (fd))
				break;
		}
		fclose (fd);
		count = x;
	}
}

void add_addr (struct addr_db addrnew) {
	strcpy (addrdb[count].name, addrnew.name);
	strcpy (addrdb[count].lastname, addrnew.lastname);
	strcpy (addrdb[count].tel, addrnew.tel);
	strcpy (addrdb[count].street, addrnew.street);
	strcpy (addrdb[count].city, addrnew.city);
	strcpy (addrdb[count].zip, addrnew.zip);
	strcpy (addrdb[count].state, addrnew.state);
	strcpy (addrdb[count].mail, addrnew.mail);
	strcpy (addrdb[count].home, addrnew.home);
	strcpy (addrdb[count].icq, addrnew.icq);
	strcpy (addrdb[count].irc, addrnew.irc);
	++count;
}

void edit_addr (int number, struct addr_db addrnew) {
	strcpy (addrdb[number].name, addrnew.name);
	strcpy (addrdb[number].lastname, addrnew.lastname);
	strcpy (addrdb[number].tel, addrnew.tel);
	strcpy (addrdb[number].street, addrnew.street);
	strcpy (addrdb[number].city, addrnew.city);
	strcpy (addrdb[number].zip, addrnew.zip);
	strcpy (addrdb[number].state, addrnew.state);
	strcpy (addrdb[number].mail, addrnew.mail);
	strcpy (addrdb[number].home, addrnew.home);
	strcpy (addrdb[number].icq, addrnew.icq);
	strcpy (addrdb[number].irc, addrnew.irc);
}

void delete_addr (int number) {
	int x;

	for (x = number; x < count - 1; x++)
		memcpy (&addrdb[x], &addrdb[x + 1], sizeof (addrdb[x]));
	--count;
}

void finish_addr () {
	int x;
	char file[256];
	FILE *fd;

	sprintf (file, "%s/.address", getenv ("HOME"));

	if (fd = fopen (file, "w")) {
			for (x = 0; x < count; x++) {
				fprintf (fd, "%s\n", addrdb[x].name);
				fprintf (fd, "%s\n", addrdb[x].lastname);
				fprintf (fd, "%s\n", addrdb[x].tel);
				fprintf (fd, "%s\n", addrdb[x].street);
				fprintf (fd, "%s\n", addrdb[x].city);
				fprintf (fd, "%s\n", addrdb[x].zip);
				fprintf (fd, "%s\n", addrdb[x].state);
				fprintf (fd, "%s\n", addrdb[x].mail);
				fprintf (fd, "%s\n", addrdb[x].home);
				fprintf (fd, "%s\n", addrdb[x].icq);
				fprintf (fd, "%s\n", addrdb[x].irc);
			}
		fclose (fd);
	}
}

int main (int argc, char *argv[]) {
	int retval = 0;

	newtInit ();
	newtSetColors (newtColorsInit ());
	newtCls ();
	newtDrawRootText (0, 0, "AddressBook, (C) Vladyslav Zubkis 2000 <cw2000@freenet.de>");

	init_addr ();

	while ((retval > -2) && (retval < 2048)) {
		retval = main_form (addrdb, count);
		if (retval == -1) {
			struct addr_db addrnew;
			if (add_form (&addrnew))
				add_addr (addrnew);
			continue;
		}
		if ((retval < 1024) && (retval > -1))
			if (show_form (addrdb[retval])) {
				struct addr_db addrnew;
				if (edit_form (addrdb[retval], &addrnew))
					edit_addr (retval, addrnew);
				continue;
			}
		if ((retval > 1023) && (retval < 2048))
			delete_addr (retval - 1024);
	}

	finish_addr ();

	newtCls ();
	newtFinished ();

	return 0;
}
