#include <newt.h>
#include <stdio.h>
#include "address.h"

int main_form (struct addr_db *addrdb, int count) {
	int rows, cols;
	int ptr[1024], x, retval = -2, ret;
	struct newtExitStruct event;
	newtComponent form, list, border, button_show, button_add, button_delete, button_exit;

	newtGetScreenSize (&cols, &rows);
	newtPushHelpLine ("<RETURN> show | <INSERT> add | <DEL> delete | <F12> exit | <TAB>/<ALT-TAB> move");
	newtCenteredWindow (60, rows - 7, "AddressBook");
	form = newtForm (NULL, NULL, 0);
	list = newtListbox (2, 1, rows - 13, NEWT_FLAG_SCROLL|NEWT_FLAG_RETURNEXIT);
	newtListboxSetWidth (list, 57);
	border = newtListbox (1, 0, rows - 11, NEWT_FLAG_BORDER);
	newtListboxSetWidth (border, 58);
	newtComponentTakesFocus (border, 0);
	button_show = newtButton (1, rows - 11,    "  Show  ");
	button_add = newtButton (16, rows - 11,    "   Add  ");
	button_delete = newtButton (31, rows - 11, " Delete ");
	button_exit = newtButton (46, rows - 11,   "  Exit  ");
	newtFormAddComponents (form, border, list, button_show, button_add, button_delete, button_exit, NULL);
	newtFormAddHotKey (form, NEWT_KEY_INSERT);
	newtFormAddHotKey (form, NEWT_KEY_DELETE);

	for (x = 0; x < count; x++) {
		char string[256];
		ptr[x] = x;
		sprintf (string, "%s %s", addrdb[x].name, addrdb[x].lastname);
		newtListboxAppendEntry (list, string, &ptr[x]);
	}

	newtFormRun (form, &event);
	newtPopWindow ();
	newtPopHelpLine ();

	if (count > 0)
		memcpy (&ret, newtListboxGetCurrent (list), sizeof (ret));
	if (event.reason == NEWT_EXIT_COMPONENT) {
		if (event.u.co == button_show)
			retval = ret;
		if (event.u.co == button_add)
			retval = -1;
		if (event.u.co == button_delete)
			retval = 1024 + ret;
		if (event.u.co == list)
			retval = ret;
	}
	if (event.reason == NEWT_EXIT_HOTKEY) {
		if (event.u.key == NEWT_KEY_INSERT)
			retval = -1;
		if (event.u.key == NEWT_KEY_DELETE)
			retval = 1024 + ret;
	}
	
	newtFormDestroy (form);
	return retval;
}

int add_form (struct addr_db *addrdb) {
	struct newtExitStruct event;
	int retval = 0;
	char *data[11];
	newtComponent label_name, label_lastname, label_tel, label_street, label_city, label_zip, label_state, label_mail, label_home, label_icq, label_irc;
	newtComponent entry_name, entry_lastname, entry_tel, entry_street, entry_city, entry_zip, entry_state, entry_mail, entry_home, entry_icq, entry_irc;
	newtComponent button_ok, button_cancel, form;

	newtPushHelpLine ("<F12> cancel");
	newtCenteredWindow (45, 19, "Add new address");
	form = newtForm (NULL, NULL, 0);
	label_name = newtLabel (1, 1,     "           Name:");
	label_lastname = newtLabel (1, 2, "      Last name:");
	label_tel = newtLabel (1, 4,      "        Telefon:");
	label_street = newtLabel (1, 5,   "         Street:");
	label_city = newtLabel (1, 6,     "      City/Town:");
	label_zip = newtLabel (1, 7,      "ZIP/Postal code:");
	label_state = newtLabel (1, 8,    "        Country:");
	label_mail = newtLabel (1, 10,    "          eMail:");
	label_home = newtLabel (1, 11,    "       Homepage:");
	label_icq = newtLabel (1, 12,     "           ICQ#:");
	label_irc = newtLabel (1, 13,     "            IRC:");
	entry_name = newtEntry (18, 1, "\0", 26, &data[0], NEWT_FLAG_SCROLL);
	entry_lastname = newtEntry (18, 2, "\0", 26, &data[1], NEWT_FLAG_SCROLL);
	entry_tel = newtEntry (18, 4, "\0", 26, &data[2], NEWT_FLAG_SCROLL);
	entry_street = newtEntry (18, 5, "\0", 26, &data[3], NEWT_FLAG_SCROLL);
	entry_city = newtEntry (18, 6, "\0", 26, &data[4], NEWT_FLAG_SCROLL);
	entry_zip = newtEntry (18, 7, "\0", 26, &data[5], NEWT_FLAG_SCROLL);
	entry_state = newtEntry (18, 8, "\0", 26, &data[6], NEWT_FLAG_SCROLL);
	entry_mail = newtEntry (18, 10, "\0", 26, &data[7], NEWT_FLAG_SCROLL);
	entry_home = newtEntry (18, 11, "\0", 26, &data[8], NEWT_FLAG_SCROLL);
	entry_icq = newtEntry (18, 12, "\0", 26, &data[9], NEWT_FLAG_SCROLL);
	entry_irc = newtEntry (18, 13, "\0", 26, &data[10], NEWT_FLAG_SCROLL);
	button_ok = newtButton (9, 15, "   OK   ");
	button_cancel = newtButton (23, 15, " Cancel ");
	newtFormAddComponents (form, label_name, label_lastname, label_tel, label_city, label_street, label_zip, label_state, label_mail, label_home, label_icq, label_irc, NULL);
	newtFormAddComponents (form, entry_name, entry_lastname, entry_tel, entry_street, entry_city, entry_zip, entry_state, entry_mail, entry_home, entry_icq, entry_irc, NULL);
	newtFormAddComponents (form, button_ok, button_cancel, NULL);

	newtFormRun (form, &event);
	newtPopWindow ();
	newtPopHelpLine ();

	strcpy (addrdb->name, (strlen (data[0]))?data[0]:"-");
	strcpy (addrdb->lastname, (strlen (data[1]))?data[1]:"-");
	strcpy (addrdb->tel, (strlen (data[2]))?data[2]:"-");
	strcpy (addrdb->street, (strlen (data[3]))?data[3]:"-");
	strcpy (addrdb->city, (strlen (data[4]))?data[4]:"-");
	strcpy (addrdb->zip, (strlen (data[5]))?data[5]:"-");
	strcpy (addrdb->state, (strlen (data[6]))?data[6]:"-");
	strcpy (addrdb->mail, (strlen (data[7]))?data[7]:"-");
	strcpy (addrdb->home, (strlen (data[8]))?data[8]:"-");
	strcpy (addrdb->icq, (strlen (data[9]))?data[9]:"-");
	strcpy (addrdb->irc, (strlen (data[10]))?data[10]:"-");

	if (event.reason == NEWT_EXIT_COMPONENT)
		if (event.u.co == button_ok)
			retval = 1;
	
	newtFormDestroy (form);
	return retval;
}

int edit_form (struct addr_db olddata, struct addr_db *addrdb) {
	struct newtExitStruct event;
	char *data[11];
	int retval = 0;
	newtComponent label_name, label_lastname, label_tel, label_street, label_city, label_zip, label_state, label_mail, label_home, label_icq, label_irc;
	newtComponent entry_name, entry_lastname, entry_tel, entry_street, entry_city, entry_zip, entry_state, entry_mail, entry_home, entry_icq, entry_irc;
	newtComponent button_ok, button_cancel, form;

	newtPushHelpLine ("<F12> cancel");
	newtCenteredWindow (45, 19, "Edit address");
	form = newtForm (NULL, NULL, 0);
	label_name = newtLabel (1, 1,     "           Name:");
	label_lastname = newtLabel (1, 2, "      Last name:");
	label_tel = newtLabel (1, 4,      "        Telefon:");
	label_street = newtLabel (1, 5,   "         Street:");
	label_city = newtLabel (1, 6,     "      City/Town:");
	label_zip = newtLabel (1, 7,      "ZIP/Postal code:");
	label_state = newtLabel (1, 8,    "        Country:");
	label_mail = newtLabel (1, 10,    "          eMail:");
	label_home = newtLabel (1, 11,    "       Homepage:");
	label_icq = newtLabel (1, 12,     "           ICQ#:");
	label_irc = newtLabel (1, 13,     "            IRC:");
	entry_name = newtEntry (18, 1, olddata.name, 26, &data[0], NEWT_FLAG_SCROLL);
	entry_lastname = newtEntry (18, 2, olddata.lastname, 26, &data[1], NEWT_FLAG_SCROLL);
	entry_tel = newtEntry (18, 4, olddata.tel, 26, &data[2], NEWT_FLAG_SCROLL);
	entry_street = newtEntry (18, 5, olddata.street, 26, &data[3], NEWT_FLAG_SCROLL);
	entry_city = newtEntry (18, 6, olddata.city, 26, &data[4], NEWT_FLAG_SCROLL);
	entry_zip = newtEntry (18, 7, olddata.zip, 26, &data[5], NEWT_FLAG_SCROLL);
	entry_state = newtEntry (18, 8, olddata.state, 26, &data[6], NEWT_FLAG_SCROLL);
	entry_mail = newtEntry (18, 10, olddata.mail, 26, &data[7], NEWT_FLAG_SCROLL);
	entry_home = newtEntry (18, 11, olddata.home, 26, &data[8], NEWT_FLAG_SCROLL);
	entry_icq = newtEntry (18, 12, olddata.icq, 26, &data[9], NEWT_FLAG_SCROLL);
	entry_irc = newtEntry (18, 13, olddata.irc, 26, &data[10], NEWT_FLAG_SCROLL);
	button_ok = newtButton (9, 15, "   OK   ");
	button_cancel = newtButton (23, 15, " Cancel ");
	newtFormAddComponents (form, label_name, label_lastname, label_tel, label_city, label_street, label_zip, label_state, label_mail, label_home, label_icq, label_irc, NULL);
	newtFormAddComponents (form, entry_name, entry_lastname, entry_tel, entry_street, entry_city, entry_zip, entry_state, entry_mail, entry_home, entry_icq, entry_irc, NULL);
	newtFormAddComponents (form, button_ok, button_cancel, NULL);

	newtFormRun (form, &event);
	newtPopWindow ();
	newtPopHelpLine ();

	strcpy (addrdb->name, (strlen (data[0]))?data[0]:"-");
	strcpy (addrdb->lastname, (strlen (data[1]))?data[1]:"-");
	strcpy (addrdb->tel, (strlen (data[2]))?data[2]:"-");
	strcpy (addrdb->street, (strlen (data[3]))?data[3]:"-");
	strcpy (addrdb->city, (strlen (data[4]))?data[4]:"-");
	strcpy (addrdb->zip, (strlen (data[5]))?data[5]:"-");
	strcpy (addrdb->state, (strlen (data[6]))?data[6]:"-");
	strcpy (addrdb->mail, (strlen (data[7]))?data[7]:"-");
	strcpy (addrdb->home, (strlen (data[8]))?data[8]:"-");
	strcpy (addrdb->icq, (strlen (data[9]))?data[9]:"-");
	strcpy (addrdb->irc, (strlen (data[10]))?data[10]:"-");

	if (event.reason == NEWT_EXIT_COMPONENT)
		if (event.u.co == button_ok)
			retval = 1;
	
	newtFormDestroy (form);
	return retval;
}

int show_form (struct addr_db addrdb) {
	struct newtExitStruct event;
	int retval = 0;
	newtComponent label_name, label_lastname, label_tel, label_street, label_city, label_zip, label_state, label_mail, label_home, label_icq, label_irc;
	newtComponent entry_name, entry_lastname, entry_tel, entry_street, entry_city, entry_zip, entry_state, entry_mail, entry_home, entry_icq, entry_irc;
	newtComponent button_ok, button_edit, form;

	newtPushHelpLine ("<F12> cancel");
	newtCenteredWindow (65, 19, addrdb.name);

	form = newtForm (NULL, NULL, 0);
	label_name = newtLabel (1, 1,     "           Name:");
	label_lastname = newtLabel (1, 2, "      Last name:");
	label_tel = newtLabel (1, 4,      "        Telefon:");
	label_street = newtLabel (1, 5,   "         Street:");
	label_city = newtLabel (1, 6,     "      City/Town:");
	label_zip = newtLabel (1, 7,      "ZIP/Postal code:");
	label_state = newtLabel (1, 8,    "        Country:");
	label_mail = newtLabel (1, 10,    "          eMail:");
	label_home = newtLabel (1, 11,    "       Homepage:");
	label_icq = newtLabel (1, 12,     "           ICQ#:");
	label_irc = newtLabel (1, 13,     "            IRC:");
	entry_name = newtLabel (18, 1, addrdb.name);
	entry_lastname = newtLabel (18, 2, addrdb.lastname);
	entry_tel = newtLabel (18, 4, addrdb.tel);
	entry_street = newtLabel (18, 5, addrdb.street);
	entry_city = newtLabel (18, 6, addrdb.city);
	entry_zip = newtLabel (18, 7, addrdb.zip);
	entry_state = newtLabel (18, 8, addrdb.state);
	entry_mail = newtLabel (18, 10, addrdb.mail);
	entry_home = newtLabel (18, 11, addrdb.home);
	entry_icq = newtLabel (18, 12, addrdb.icq);
	entry_irc = newtLabel (18, 13, addrdb.irc);
	button_ok = newtButton (19, 15, "   OK   ");
	button_edit = newtButton (33, 15, "  Edit  ");
	newtFormAddComponents (form, label_name, label_lastname, label_tel, label_city, label_street, label_zip, label_state, label_mail, label_home, label_icq, label_irc, NULL);
	newtFormAddComponents (form, entry_name, entry_lastname, entry_tel, entry_street, entry_city, entry_zip, entry_state, entry_mail, entry_home, entry_icq, entry_irc, NULL);
	newtFormAddComponents (form, button_ok, button_edit, NULL);

	newtFormRun (form, &event);
	newtPopWindow ();
	newtPopHelpLine ();

	if (event.reason == NEWT_EXIT_COMPONENT)
		if (event.u.co == button_edit)
			retval = 1;

	newtFormDestroy (form);
	return retval;
}
